Package com.smartgwt.client.util

# Class MockDSExportSettings

java.lang.Object
com.smartgwt.client.core.JsObject
com.smartgwt.client.core.DataClass
com.smartgwt.client.util.MockDSExportSettings

All Implemented Interfaces:
  `HasHandlers`

public class MockDSExportSettings extends DataClass
Settings used to control the export or serialization of a `DataSource` by `Reify.getMockDS()`.

- ## Field Summary

  ### Fields inherited from class com.smartgwt.client.core.DataClass

  `factoryCreated, factoryProperties`

  ### Fields inherited from class com.smartgwt.client.core.JsObject

  `jsObj`

- ## Constructor Summary

  Constructors
  Constructor
  Description
  `MockDSExportSettings()`
  `MockDSExportSettings(JavaScriptObject jsObj)`

- ## Method Summary

  Modifier and Type
  Method
  Description
  `Criteria`
  `getCriteria()`
  The `criteria` used to fetch the records returned as part of the export or serialization.
  `int`
  `getFollowFKDepth()`
  When non-zero, automatically discovers `DataSources` reachable from the explicitly requested DataSources via `foreignKey` relationships, up to this many hops.
  `MockDSExportFormat`
  `getFormat()`
  Determines the format emitted by `Reify.getMockDS()`.
  `boolean`
  `getIncludeCustomSimpleTypes()`
  Whether to include custom-defined `SimpleTypes`.
  `boolean`
  `getIncludeFKs()`
  Should `foreign key` relationships be included in the export or serialization of the `DataSource`?
  `boolean`
  `getIncludeImageFields()`
  Should `image fields` be included in the export or serialization of the `DataSource`? They are excluded by default since the stored paths are unlikely to be correct when placed in any other environment, such as Reify.
  `int`
  `getNumLevels()`
  The number of levels of nodes to include, for DataSources that define a `tree relationship` between fields by declaring a `foreignKey` on one field that refers to another from that same DataSource.
  `int`
  `getNumRows()`
  The number of rows of data to include, if more meet the `criteria`.
  `String[]`
  `getOmitRelations()`
  If including `foreign key` relationships, those relationships to skip.
  `static MockDSExportSettings`
  `getOrCreateRef(JavaScriptObject jsObj)`
  `DSRequest[]`
  `getRequestProperties()`
  The properties that will be specified on the `DSRequest` when fetching records.
  `DSRequest`
  `getRequestPropertiesAsDSRequest()`
  The properties that will be specified on the `DSRequest` when fetching records.
  `boolean`
  `getRootCriteriaOnly()`
  For DataSources that define a `tree relationship` between fields by declaring a `foreignKey` on one field that refers to another from that same DataSource, should `criteria` be applied only to the root node? If false, the criteria will be applied to all nodes.
  `MockDSExportValidatorMode`
  `getValidatorMode()`
  Controls which `validators`, if any, to include in the fields of the exported `MockDataSource`.
  `MockDSExportSettings`
  `setCriteria(Criteria criteria)`
  The `criteria` used to fetch the records returned as part of the export or serialization.
  `MockDSExportSettings`
  `setFollowFKDepth(int followFKDepth)`
  When non-zero, automatically discovers `DataSources` reachable from the explicitly requested DataSources via `foreignKey` relationships, up to this many hops.
  `MockDSExportSettings`
  `setFormat(MockDSExportFormat format)`
  Determines the format emitted by `Reify.getMockDS()`.
  `MockDSExportSettings`
  `setIncludeCustomSimpleTypes(boolean includeCustomSimpleTypes)`
  Whether to include custom-defined `SimpleTypes`.
  `MockDSExportSettings`
  `setIncludeFKs(boolean includeFKs)`
  Should `foreign key` relationships be included in the export or serialization of the `DataSource`?
  `MockDSExportSettings`
  `setIncludeImageFields(boolean includeImageFields)`
  Should `image fields` be included in the export or serialization of the `DataSource`? They are excluded by default since the stored paths are unlikely to be correct when placed in any other environment, such as Reify.
  `MockDSExportSettings`
  `setNumLevels(int numLevels)`
  The number of levels of nodes to include, for DataSources that define a `tree relationship` between fields by declaring a `foreignKey` on one field that refers to another from that same DataSource.
  `MockDSExportSettings`
  `setNumRows(int numRows)`
  The number of rows of data to include, if more meet the `criteria`.
  `MockDSExportSettings`
  `setOmitRelations(String... omitRelations)`
  If including `foreign key` relationships, those relationships to skip.
  `MockDSExportSettings`
  `setRequestProperties(DSRequest requestProperties)`
  The properties that will be specified on the `DSRequest` when fetching records.
  `MockDSExportSettings`
  `setRequestProperties(DSRequest... requestProperties)`
  The properties that will be specified on the `DSRequest` when fetching records.
  `MockDSExportSettings`
  `setRootCriteriaOnly(boolean rootCriteriaOnly)`
  For DataSources that define a `tree relationship` between fields by declaring a `foreignKey` on one field that refers to another from that same DataSource, should `criteria` be applied only to the root node? If false, the criteria will be applied to all nodes.
  `MockDSExportSettings`
  `setValidatorMode(MockDSExportValidatorMode validatorMode)`
  Controls which `validators`, if any, to include in the fields of the exported `MockDataSource`.

  ### Methods inherited from class com.smartgwt.client.core.DataClass

  `applyFactoryProperties, doAddHandler, fireEvent, getAttribute, getAttributeAsBoolean, getAttributeAsBoolean, getAttributeAsDate, getAttributeAsDouble, getAttributeAsDoubleArray, getAttributeAsElement, getAttributeAsFloat, getAttributeAsInt, getAttributeAsIntArray, getAttributeAsJavaScriptObject, getAttributeAsLong, getAttributeAsMap, getAttributeAsObject, getAttributeAsRecord, getAttributeAsString, getAttributeAsStringArray, getAttributes, getHandlerCount, isFactoryCreated, setAttribute, setAttribute, setAttribute, setAttribute, setAttribute, setAttribute, setAttribute, setAttribute, setAttribute, setAttribute, setAttribute, setAttribute, setAttribute, setAttribute, setAttribute, setAttribute, setAttribute, setAttribute, setAttribute, setAttribute, setAttribute, setAttribute, setAttribute, setAttribute, setAttributeAsJavaObject, setFactoryCreated`

  ### Methods inherited from class com.smartgwt.client.core.JsObject

  `equals, getJsObj, hashCode, isCreated, setJavaScriptObject, setJsObj`

  ### Methods inherited from class java.lang.Object

  `clone, finalize, getClass, notify, notifyAll, toString, wait, wait, wait`

- ## Constructor Details

  - ### MockDSExportSettings

    public MockDSExportSettings()

  - ### MockDSExportSettings

    public MockDSExportSettings(JavaScriptObject jsObj)

- ## Method Details

  - ### getOrCreateRef

    public static MockDSExportSettings getOrCreateRef(JavaScriptObject jsObj)

  - ### setCriteria

    public MockDSExportSettings setCriteria(Criteria criteria)
    The `criteria` used to fetch the records returned as part of the export or serialization.
    Parameters:
      `criteria` - New criteria value. Default value is null
    Returns:
      `MockDSExportSettings` instance, for chaining setter calls

  - ### getCriteria

    public Criteria getCriteria()
    The `criteria` used to fetch the records returned as part of the export or serialization.
    Returns:
      Current criteria value. Default value is null

  - ### setFollowFKDepth

    public MockDSExportSettings setFollowFKDepth(int followFKDepth)
    When non-zero, automatically discovers `DataSources` reachable from the explicitly requested DataSources via `foreignKey` relationships, up to this many hops. A value of 1 adds DataSources directly referenced by a foreignKey on any requested DataSource; a value of 2 additionally adds DataSources referenced by those, and so on.

    This is useful when exporting a set of interlinked DataSources and you want to automatically include all related DataSources without enumerating them manually. The traversal walks both directions: from a field's `foreignKey` to the target DataSource, and from a target DataSource back to any DataSource that references it. Self-referential (tree) FKs are not counted as a hop.

    Parameters:
      `followFKDepth` - New followFKDepth value. Default value is 0
    Returns:
      `MockDSExportSettings` instance, for chaining setter calls

  - ### getFollowFKDepth

    public int getFollowFKDepth()
    When non-zero, automatically discovers `DataSources` reachable from the explicitly requested DataSources via `foreignKey` relationships, up to this many hops. A value of 1 adds DataSources directly referenced by a foreignKey on any requested DataSource; a value of 2 additionally adds DataSources referenced by those, and so on.

    This is useful when exporting a set of interlinked DataSources and you want to automatically include all related DataSources without enumerating them manually. The traversal walks both directions: from a field's `foreignKey` to the target DataSource, and from a target DataSource back to any DataSource that references it. Self-referential (tree) FKs are not counted as a hop.

    Returns:
      Current followFKDepth value. Default value is 0

  - ### setFormat

    public MockDSExportSettings setFormat(MockDSExportFormat format)
    Determines the format emitted by `Reify.getMockDS()`.
    Parameters:
      `format` - New format value. Default value is "xmlMockDS"
    Returns:
      `MockDSExportSettings` instance, for chaining setter calls

  - ### getFormat

    public MockDSExportFormat getFormat()
    Determines the format emitted by `Reify.getMockDS()`.
    Returns:
      Current format value. Default value is "xmlMockDS"

  - ### setIncludeCustomSimpleTypes

    public MockDSExportSettings setIncludeCustomSimpleTypes(boolean includeCustomSimpleTypes)
    Whether to include custom-defined `SimpleTypes`.
    Parameters:
      `includeCustomSimpleTypes` - New includeCustomSimpleTypes value. Default value is false
    Returns:
      `MockDSExportSettings` instance, for chaining setter calls

  - ### getIncludeCustomSimpleTypes

    public boolean getIncludeCustomSimpleTypes()
    Whether to include custom-defined `SimpleTypes`.
    Returns:
      Current includeCustomSimpleTypes value. Default value is false

  - ### setIncludeFKs

    public MockDSExportSettings setIncludeFKs(boolean includeFKs)
    Should `foreign key` relationships be included in the export or serialization of the `DataSource`?
    Parameters:
      `includeFKs` - New includeFKs value. Default value is true
    Returns:
      `MockDSExportSettings` instance, for chaining setter calls

  - ### getIncludeFKs

    public boolean getIncludeFKs()
    Should `foreign key` relationships be included in the export or serialization of the `DataSource`?
    Returns:
      Current includeFKs value. Default value is true

  - ### setIncludeImageFields

    public MockDSExportSettings setIncludeImageFields(boolean includeImageFields)
    Should `image fields` be included in the export or serialization of the `DataSource`? They are excluded by default since the stored paths are unlikely to be correct when placed in any other environment, such as Reify.
    Parameters:
      `includeImageFields` - New includeImageFields value. Default value is false
    Returns:
      `MockDSExportSettings` instance, for chaining setter calls

  - ### getIncludeImageFields

    public boolean getIncludeImageFields()
    Should `image fields` be included in the export or serialization of the `DataSource`? They are excluded by default since the stored paths are unlikely to be correct when placed in any other environment, such as Reify.
    Returns:
      Current includeImageFields value. Default value is false

  - ### setNumLevels

    public MockDSExportSettings setNumLevels(int numLevels)
    The number of levels of nodes to include, for DataSources that define a `tree relationship` between fields by declaring a `foreignKey` on one field that refers to another from that same DataSource.
    Parameters:
      `numLevels` - New numLevels value. Default value is 3
    Returns:
      `MockDSExportSettings` instance, for chaining setter calls
    See Also:
      - `setRootCriteriaOnly(boolean)`

  - ### getNumLevels

    public int getNumLevels()
    The number of levels of nodes to include, for DataSources that define a `tree relationship` between fields by declaring a `foreignKey` on one field that refers to another from that same DataSource.
    Returns:
      Current numLevels value. Default value is 3
    See Also:
      - `getRootCriteriaOnly()`

  - ### setNumRows

    public MockDSExportSettings setNumRows(int numRows)
    The number of rows of data to include, if more meet the `criteria`.
    Parameters:
      `numRows` - New numRows value. Default value is 20
    Returns:
      `MockDSExportSettings` instance, for chaining setter calls

  - ### getNumRows

    public int getNumRows()
    The number of rows of data to include, if more meet the `criteria`.
    Returns:
      Current numRows value. Default value is 20

  - ### setOmitRelations

    public MockDSExportSettings setOmitRelations(String... omitRelations)
    If including `foreign key` relationships, those relationships to skip. This can be used to avoid dangling references to `DataSources` that are not being exported or serialized.
    Parameters:
      `omitRelations` - New omitRelations value. Default value is null
    Returns:
      `MockDSExportSettings` instance, for chaining setter calls
    See Also:
      - `setIncludeFKs(boolean)`

  - ### getOmitRelations

    public String[] getOmitRelations()
    If including `foreign key` relationships, those relationships to skip. This can be used to avoid dangling references to `DataSources` that are not being exported or serialized.
    Returns:
      Current omitRelations value. Default value is null
    See Also:
      - `getIncludeFKs()`

  - ### setRequestProperties

    public MockDSExportSettings setRequestProperties(DSRequest... requestProperties)
    The properties that will be specified on the `DSRequest` when fetching records. You can pass an array of different request properties matching the length of the `dsNames` param of `Reify.getMockDS()` or `Reify.showMockDS()` if you want the fetch for each `DataSource` made with different properties.
    Parameters:
      `requestProperties` - New requestProperties value. Default value is null
    Returns:
      `MockDSExportSettings` instance, for chaining setter calls

  - ### getRequestProperties

    public DSRequest[] getRequestProperties()
    The properties that will be specified on the `DSRequest` when fetching records. You can pass an array of different request properties matching the length of the `dsNames` param of `Reify.getMockDS()` or `Reify.showMockDS()` if you want the fetch for each `DataSource` made with different properties.
    Returns:
      Current requestProperties value. Default value is null

  - ### setRequestProperties

    public MockDSExportSettings setRequestProperties(DSRequest requestProperties)
    The properties that will be specified on the `DSRequest` when fetching records. You can pass an array of different request properties matching the length of the `dsNames` param of `Reify.getMockDS()` or `Reify.showMockDS()` if you want the fetch for each `DataSource` made with different properties.
    Parameters:
      `requestProperties` - New requestProperties value. Default value is null
    Returns:
      `MockDSExportSettings` instance, for chaining setter calls

  - ### getRequestPropertiesAsDSRequest

    public DSRequest getRequestPropertiesAsDSRequest()
    The properties that will be specified on the `DSRequest` when fetching records. You can pass an array of different request properties matching the length of the `dsNames` param of `Reify.getMockDS()` or `Reify.showMockDS()` if you want the fetch for each `DataSource` made with different properties.
    Returns:
      Current requestProperties value. Default value is null

  - ### setRootCriteriaOnly

    public MockDSExportSettings setRootCriteriaOnly(boolean rootCriteriaOnly)
    For DataSources that define a `tree relationship` between fields by declaring a `foreignKey` on one field that refers to another from that same DataSource, should `criteria` be applied only to the root node? If false, the criteria will be applied to all nodes.
    Parameters:
      `rootCriteriaOnly` - New rootCriteriaOnly value. Default value is false
    Returns:
      `MockDSExportSettings` instance, for chaining setter calls
    See Also:
      - `setNumLevels(int)`

  - ### getRootCriteriaOnly

    public boolean getRootCriteriaOnly()
    For DataSources that define a `tree relationship` between fields by declaring a `foreignKey` on one field that refers to another from that same DataSource, should `criteria` be applied only to the root node? If false, the criteria will be applied to all nodes.
    Returns:
      Current rootCriteriaOnly value. Default value is false
    See Also:
      - `getNumLevels()`

  - ### setValidatorMode

    public MockDSExportSettings setValidatorMode(MockDSExportValidatorMode validatorMode)
    Controls which `validators`, if any, to include in the fields of the exported `MockDataSource`. Since MockDataSources are client-only, server-only validators are not exported. Auto-generated validators are also not exported, since they will be recreated based on the type of the field during the import process.
    Parameters:
      `validatorMode` - New validatorMode value. Default value is "standard"
    Returns:
      `MockDSExportSettings` instance, for chaining setter calls

  - ### getValidatorMode

    public MockDSExportValidatorMode getValidatorMode()
    Controls which `validators`, if any, to include in the fields of the exported `MockDataSource`. Since MockDataSources are client-only, server-only validators are not exported. Auto-generated validators are also not exported, since they will be recreated based on the type of the field during the import process.
    Returns:
      Current validatorMode value. Default value is "standard"